/*
 * Copyright (C) 2024 Das Land Schleswig-Holstein vertreten durch den
 * Ministerpräsidenten des Landes Schleswig-Holstein
 * Staatskanzlei
 * Abteilung Digitalisierung und zentrales IT-Management der Landesregierung
 *
 * Lizenziert unter der EUPL, Version 1.2 oder - sobald
 * diese von der Europäischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie dürfen dieses Werk ausschließlich gemäß
 * dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 *
 * https://joinup.ec.europa.eu/collection/eupl/eupl-text-eupl-12
 *
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie
 * ist", OHNE JEGLICHE GEWÄHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrücklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschränkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */
package de.ozgcloud.archive.vorgang;

import java.time.ZonedDateTime;
import java.util.UUID;

import com.thedeanda.lorem.LoremIpsum;

import de.ozgcloud.archive.common.XDomeaTestUtils;
import de.ozgcloud.common.test.TestUtils;

public class VorgangWithEingangTestFactory {

	public static final String ID = XDomeaTestUtils.createMongoDbObjectId();
	public static final String NUMMER = UUID.randomUUID().toString();
	public static final String AKTENZEICHEN = UUID.randomUUID().toString();
	public static final String NAME = LoremIpsum.getInstance().getWords(5);
	public static final ZonedDateTime CREATED_AT = ZonedDateTime.now();

	public static VorgangWithEingang create() {
		return createBuilder().build();
	}

	public static VorgangWithEingang.VorgangWithEingangBuilder createBuilder() {
		return VorgangWithEingang.builder()
				.id(ID)
				.name(NAME)
				.nummer(NUMMER)
				.aktenzeichen(AKTENZEICHEN)
				.createdAt(CREATED_AT)
				.eingang(EingangTestFactory.create());
	}

	public static String buildMinimalVorgangAsXml() {
		return TestUtils.loadTextFile("xml-templates/vorgang.xml.template");
	}
}
